// RCEncoding.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "RCEncoding.h"

#define MAX_LOADSTRING 100

// Global Variables:
TCHAR szTitle[MAX_LOADSTRING];					// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];			// the main window class name
TCHAR szProgInfo[1024];			// the main window class name
HMODULE hResInst = NULL;

// Forward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	About(HWND, UINT, WPARAM, LPARAM);
HFONT MakeJapaneseFont( LPCTSTR szFontName );

#ifdef UNICODE
	WCHAR const * const FONTNAME_LOCAL = L"\xff2d\xff33 \x30b4\x30b7\x30c3\x30af";
#else
// not using char const * const FONTNAME_LOCAL = "lr SVbN"
// because it depends on ANSI code page of the machine used to compile
// (and I don't like pragma locale)
	BYTE FONTNAME_LOCAL_BYTES[] = { 0x82, 0x6C, 0x82, 0x72, 0x20, 0x83, 0x53, 0x83, 0x56, 0x83, 0x62, 0x83, 0x4E };
	char const * const FONTNAME_LOCAL = (char const *)FONTNAME_LOCAL_BYTES;
#endif // UNICODE

int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);
	hResInst = LoadLibrary( lpCmdLine );
	if( !hResInst )
		hResInst = hInstance;

	TCHAR szDll[MAX_PATH];
	TCHAR szApp[MAX_PATH];
	TCHAR fname[_MAX_FNAME], ext[_MAX_EXT];

	GetModuleFileName( hResInst, szDll, _countof(szDll) );
	_tsplitpath_s( szDll, NULL, 0, NULL, 0, fname, _countof(fname), ext, _countof(ext) );
	_tmakepath_s( szDll, _countof(szDll), NULL, NULL, fname, ext );

	GetModuleFileName( hInstance, szApp, _countof(szApp) );
	_tsplitpath_s( szApp, NULL, 0, NULL, 0, fname, _countof(fname), ext, _countof(ext) );
	_tmakepath_s( szApp, _countof(szApp), NULL, NULL, fname, ext );

	_sntprintf_s( szProgInfo, _countof(szProgInfo), _T("%s - %s [%s]"), szApp, szDll, FONTNAME_LOCAL );

	MSG msg;
	HACCEL hAccelTable;

	// Initialize global strings
	LoadString(hResInst, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hResInst, IDC_RCENCODING, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hResInst);

	// Perform application initialization:
	if (!InitInstance (nCmdShow))
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hResInst, MAKEINTRESOURCE(IDC_RCENCODING));

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0))
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage are only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_RCENCODING));
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= MAKEINTRESOURCE(IDC_RCENCODING);
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, MAKEINTRESOURCE(IDI_SMALL));

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(int)
//
//   PURPOSE: Creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(int nCmdShow)
{
   HWND hWnd;

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hResInst, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   return TRUE;
}

//
//  FUNCTION: WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;

	switch (message)
	{
	case WM_COMMAND:
		wmId    = LOWORD(wParam);
		wmEvent = HIWORD(wParam);
		// Parse the menu selections:
		switch (wmId)
		{
		case IDM_ALLDLG:
			MessageBox( hWnd, szTitle, szTitle, MB_OK );
			DialogBox(hResInst, MAKEINTRESOURCE(IDD_ABOUTBOX1), hWnd, About);
			DialogBox(hResInst, MAKEINTRESOURCE(IDD_ABOUTBOX2), hWnd, About);
			DialogBox(hResInst, MAKEINTRESOURCE(IDD_ABOUTBOX3), hWnd, About);
			DialogBox(hResInst, MAKEINTRESOURCE(IDD_ABOUTBOX4), hWnd, About);
			DialogBox(hResInst, MAKEINTRESOURCE(IDD_ABOUTBOX5), hWnd, About);
			DialogBox(hResInst, MAKEINTRESOURCE(IDD_ABOUTBOX6), hWnd, About);
			break;
		case IDM_EXIT:
			DestroyWindow(hWnd);
			break;
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		{
			RECT rect;
			GetClientRect( hWnd, &rect );

			rect.bottom -= 100;
			DrawText( hdc, szProgInfo, -1, &rect, DT_CENTER | DT_VCENTER | DT_SINGLELINE );

			rect.bottom += 50;
			HFONT oldFont = (HFONT)SelectObject( hdc, GetStockObject( DEFAULT_GUI_FONT ) );
			DrawText( hdc, szTitle, -1, &rect, DT_CENTER | DT_VCENTER | DT_SINGLELINE );

			HFONT hJpFont1 = MakeJapaneseFont( _T("MS Gothic") );
			HFONT hJpFont2 = MakeJapaneseFont( FONTNAME_LOCAL );

			rect.bottom += 50;
			SelectObject( hdc, hJpFont1 );
			DrawText( hdc, szTitle, -1, &rect, DT_CENTER | DT_VCENTER | DT_SINGLELINE );

			rect.bottom += 50;
			SelectObject( hdc, hJpFont2 );
			DrawText( hdc, szTitle, -1, &rect, DT_CENTER | DT_VCENTER | DT_SINGLELINE );

			SelectObject( hdc, oldFont );

			DeleteObject( hJpFont1 );
			DeleteObject( hJpFont2 );
		}
		EndPaint(hWnd, &ps);
		break;
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

HFONT MakeJapaneseFont( LPCTSTR szFontName ) {
			LOGFONT lFont;
			lFont.lfHeight = -15;
			lFont.lfWidth = 0;
			lFont.lfEscapement = 0; 
			lFont.lfOrientation = 0;
			lFont.lfWeight = FW_NORMAL;
			lFont.lfItalic = FALSE;
			lFont.lfUnderline = FALSE;
			lFont.lfStrikeOut = FALSE;
			lFont.lfCharSet = SHIFTJIS_CHARSET;
			lFont.lfOutPrecision = OUT_DEFAULT_PRECIS;
			lFont.lfClipPrecision = CLIP_DEFAULT_PRECIS;
			lFont.lfQuality = DEFAULT_QUALITY;
			lFont.lfPitchAndFamily = VARIABLE_PITCH;
			_tcsncpy_s( lFont.lfFaceName, szFontName, _countof(lFont.lfFaceName) );
			return CreateFontIndirect( &lFont );
}

// Message handler for about box.
INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
	case WM_INITDIALOG:
		return (INT_PTR)TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
		{
			EndDialog(hDlg, LOWORD(wParam));
			return (INT_PTR)TRUE;
		}
		break;
	}
	return (INT_PTR)FALSE;
}
